/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 21/05/2019
 --------------------------------------------------------
*/
package com.portofolio.entity;

import  static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;
import  javax.persistence.*;
import  javax.validation.constraints.*;

import org.hibernate.annotations.ForeignKey;

import  lombok.AllArgsConstructor;
import  lombok.Getter;
import  lombok.NoArgsConstructor;
import  lombok.Setter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.vo.ProfileConfigDesignId;


@Entity
@Table(name = "ProfileConfigDesign_S",indexes = {@Index(name = "ProfileConfigDesign_S_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class ProfileConfigDesign {
    
    @EmbeddedId
    private ProfileConfigDesignId id ;
    
    
    private static final String cDefKdBahasa =INTEGER;
    @Column(name = "KdBahasa", columnDefinition = cDefKdBahasa)
    private Integer kdBahasa;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "profileconfigdesign.statusenabled.notnull")
    private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "profileconfigdesign.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "profileconfigdesign.version.notnull")
    private Integer version;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    //@ForeignKey(name="none")
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
     private Profile profile;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    //@ForeignKey(name="none")
    @JoinColumns({
    		@JoinColumn(name = "KdModulAplikasi", referencedColumnName = "KdModulAplikasi", insertable = false, updatable = false), })
    private ModulAplikasi modulAplikasi;
    

    
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    //@ForeignKey(name="none")
    @JoinColumns({
    		@JoinColumn(name = "KdVersion", referencedColumnName = "KdVersion", insertable = false, updatable = false),
    })
    private VersionSystem versionSystem;

}
